#include <plib.h>
#include <math.h>
#include "NU32.h"
#include <dsplib_dsp.h>
#include "fftc.h"
#include "NoisySignal.h"
#include "NU32DSP.h"

/* Define constants that are used when converting the doubles to a
 * fixed-point representation.  For this problem, these values should
 * work fine, but for different amplitude signals or different order
 * filters, these may have to be adjusted.  To understand how they
 * work, see NU32DSP.c. */
#define FFT_SCALING (10)
#define FIR_COEFF_SCALE (10)
#define FIR_SIG_SCALE (10)

/* Define our FIR that was designed in MATLAB */
#define FIR_LENGTH (4)
double FIR[FIR_LENGTH] = {0,0,0,0};

/* define arrays for storing all relevant signals */
double X_FIR[SIGNAL_LENGTH];	/* for the FIR filtered signal */
double X_MAF[SIGNAL_LENGTH];	/* for the MAF filtered signal */
double FFT_ORIG[SIGNAL_LENGTH];	/* for the FFT of the noisy signal */
double FFT_FIR[SIGNAL_LENGTH];	/* FFT of the FIR filtered signal */
double FFT_MAF[SIGNAL_LENGTH];	/* FFT of the MAF filtered signal */

/*****************/
/* MAIN FUNCTION */
/*****************/
int main(void)
{
  /* indexer: */
  int i = 0;

  /* startup routines */
  NU32_Startup();
  NU32_Initialize();

  /* Perform MAF on noisySignal, and store it */
  ////////////FILL IN CODE HERE/////////////////
    
  /* Perform FIR on noisySignal and store */
  NU32_FIR_1024(X_FIR, noisySignal, FIR,
		FIR_COEFF_SCALE, FIR_SIG_SCALE, FIR_LENGTH);

  /* FFT of original signal */
  NU32_FFT_1024(FFT_ORIG, noisySignal, FFT_SCALING);

  /* Perform FFT on MAF */
  NU32_FFT_1024(FFT_MAF, X_MAF, FFT_SCALING);

  /* Perform FFT on FIR */
  NU32_FFT_1024(FFT_FIR, X_FIR, FFT_SCALING);

  /* Print the results to the computer */
  for (i=0; i<SIGNAL_LENGTH; i++) {
    sprintf(NU32_RS232OutBuffer,
	    "%12.6f %12.6f %12.6f %12.6f %12.6f %12.6f \r\n",
	    noisySignal[i], X_MAF[i], X_FIR[i],
	    FFT_ORIG[i], FFT_MAF[i], FFT_FIR[i]);
    NU32_WriteUART1(NU32_RS232OutBuffer);
  }
    

  /* Just show the PIC is still running */
  while (1) {
    WriteCoreTimer(0);
    while (ReadCoreTimer() < 4000000);
    NU32LED1 = !NU32LED1;
    NU32LED2 = !NU32LED2;
  }
  return(0);
}
